#ifndef _ADDER_H_
#define _ADDER_H_

#include <iostream>
using namespace std;

#include <systemc>
using namespace sc_dt;
using namespace sc_core;

const int WIDTH = 2;

class adder : public sc_module {
public:
  sc_in_clk i_clk;
  sc_in<bool> i_rst;
  sc_in<sc_uint<WIDTH> > i_a_port;
  sc_in<sc_uint<WIDTH> > i_b_port;
  sc_out<sc_uint<WIDTH+1> > o_sum_port;

  void do_add() {
    while (true) {
        _i_a = i_a_port.read();
        _i_b = i_b_port.read();
        _o_sum = _i_a + _i_b;
        o_sum_port.write(_o_sum);
        wait();
    }
  }

  SC_HAS_PROCESS(adder);
  adder(sc_module_name name, int i) : id(i){ 

    SC_THREAD(do_add);  
    sensitive << i_clk.pos();
    dont_initialize();
    //reset_signal_is(i_rst, false); 
  }

  sc_uint<WIDTH> i_a() { return _i_a; }
  sc_uint<WIDTH> i_b() { return _i_b; }
  sc_uint<WIDTH+1> o_sum() { return _o_sum; }

private:
  const int id;
  sc_uint<WIDTH> _i_a;
  sc_uint<WIDTH> _i_b;
  sc_uint<WIDTH + 1> _o_sum;

 
};

#endif
