#include "stim.h"
#define CLOCK_PERIOD 1.0

int sc_main(int argc, char *argv[]) {
  
  //Create modules and signals
  stim testbench("testbench");
  adder dut("dut", 1);
  sc_clock clk("clk", CLOCK_PERIOD, SC_NS);
  sc_signal<bool> rst("rst");

  //Create sc_signal channels
  sc_signal<sc_uint<WIDTH> > s_i_a;
  sc_signal<sc_uint<WIDTH> > s_i_b;
  sc_signal<sc_uint<WIDTH + 1> > s_o_sum;

  //Connect FIFO channels with modules
  testbench.i_clk(clk);
  testbench.o_rst(rst);
  dut.i_clk(clk);
  dut.i_rst(rst);
  testbench.o_a(s_i_a);
  testbench.o_b(s_i_b);
  testbench.i_sum(s_o_sum);
  dut.i_a_port(s_i_a);
  dut.i_b_port(s_i_b);
  dut.o_sum_port(s_o_sum);

  sc_start(19, SC_NS);
  return 0;
}
